module Pin
  module Generators
    class InstallGenerator < ::Rails::Generators::Base
      class_option :publishable_key, :type => :string, :banner => 'Your Pin Publishable key', :required => true
      class_option :secret_key, :type => :string, :banner => 'Your Pin Secret Key', :required => true

      def create_config_file
        template 'pin.yml', File.join('config', 'pin.yml')
      end

      def create_initializer
        template 'initializer.rb', File.join('config', 'initializers', 'pin.rb')
      end

      desc <<DESC
Description:
    Copies Pin configuration file to your application's initializer directory.
DESC

      def self.source_root
        @source_root ||= File.expand_path(File.join(File.dirname(__FILE__), 'templates'))
      end
    end
  end
end