module Pin::API::Customers

  def customers(page=1)
    raw_response = api_call(:get, 'customers', {page: page})
    pin_response(raw_response, raw_response['response'].map { |e| Pin::Models::Customer.new(e) })
  end

  def customer(token)
    raw_response = api_call(:get, "customers/#{token}")

    pin_response(raw_response, Pin::Models::Customer.new(raw_response['response']))
  end

  def customer_charges(token, page=1)
    raw_response = api_call(:get, "customers/#{token}/charges", {:page => page})

    pin_response(raw_response, raw_response['response'].map { |e| Pin::Models::Charge.new(e) })
  end

  def create_customer(email, card)
    require_field email, :email

    params = {
        :email => email
    }

    params[card.is_a?(Hash) ? :card : :card_token] = card

    raw_response = api_call(:post, 'customers', params)

    pin_response(raw_response, Pin::Models::Customer.new(raw_response['response']))
  end

  def update_customer(token, params)
    raw_response = api_call(:put, "customers/#{token}", params)
    pin_response(raw_response, Pin::Models::Customer.new(raw_response['response']))
  end
end