module Pin::API::Refunds

  def refunds(charge_token, page=1)
    raw_response = api_call(:get, "charges/#{charge_token}/refunds", {:page => page})

    pin_response(raw_response, raw_response['response'].map { |e| Pin::Models::Refund.new(e) })
  end

  def create_refund(charge_token, amount=nil)
    params = {}

    unless amount.nil?
      params[:amount] = amount
    end

    raw_response = api_call(:post, "charges/#{charge_token}/refunds", params)

    pin_response(raw_response, Pin::Models::Refund.new(raw_response['response']))
  end

end